# F64
<span class="source-link">[[Source]](src/builtin/float.md#L192)</span>
```pony
primitive val F64 is
  FloatingPoint[F64 val] val
```

#### Implements

* [FloatingPoint](builtin-FloatingPoint)\[[F64](builtin-F64) val\] val

---

## Constructors

### create
<span class="source-link">[[Source]](src/builtin/float.md#L193)</span>


```pony
new val create(
  value: F64 val = seq)
: F64 val^
```
#### Parameters

*   value: [F64](builtin-F64) val = seq

#### Returns

* [F64](builtin-F64) val^

---

### pi
<span class="source-link">[[Source]](src/builtin/float.md#L194)</span>


```pony
new val pi()
: F64 val^
```

#### Returns

* [F64](builtin-F64) val^

---

### e
<span class="source-link">[[Source]](src/builtin/float.md#L195)</span>


```pony
new val e()
: F64 val^
```

#### Returns

* [F64](builtin-F64) val^

---

### _nan
<span class="source-link">[[Source]](src/builtin/float.md#L197)</span>


```pony
new val _nan()
: F64 val^
```

#### Returns

* [F64](builtin-F64) val^

---

### _inf
<span class="source-link">[[Source]](src/builtin/float.md#L198)</span>


```pony
new val _inf(
  negative: Bool val)
: F64 val^
```
#### Parameters

*   negative: [Bool](builtin-Bool) val

#### Returns

* [F64](builtin-F64) val^

---

### from_bits
<span class="source-link">[[Source]](src/builtin/float.md#L200)</span>


```pony
new val from_bits(
  i: U64 val)
: F64 val^
```
#### Parameters

*   i: [U64](builtin-U64) val

#### Returns

* [F64](builtin-F64) val^

---

### from\[B: (([I8](builtin-I8) val | [I16](builtin-I16) val | [I32](builtin-I32) val | [I64](builtin-I64) val | [I128](builtin-I128) val | [ILong](builtin-ILong) val | [ISize](builtin-ISize) val | [U8](builtin-U8) val | [U16](builtin-U16) val | [U32](builtin-U32) val | [U64](builtin-U64) val | [U128](builtin-U128) val | [ULong](builtin-ULong) val | [USize](builtin-USize) val | [F32](builtin-F32) val | [F64](builtin-F64) val) & [Real](builtin-Real)\[B\] val)\]
<span class="source-link">[[Source]](src/builtin/float.md#L202)</span>


```pony
new val from[B: ((I8 val | I16 val | I32 val | 
    I64 val | I128 val | ILong val | 
    ISize val | U8 val | U16 val | 
    U32 val | U64 val | U128 val | 
    ULong val | USize val | F32 val | 
    F64 val) & Real[B] val)](
  a: B)
: F64 val^
```
#### Parameters

*   a: B

#### Returns

* [F64](builtin-F64) val^

---

### min_value
<span class="source-link">[[Source]](src/builtin/float.md#L204)</span>


Minimum negative value representable.


```pony
new val min_value()
: F64 val^
```

#### Returns

* [F64](builtin-F64) val^

---

### max_value
<span class="source-link">[[Source]](src/builtin/float.md#L210)</span>


Maximum positive value representable.


```pony
new val max_value()
: F64 val^
```

#### Returns

* [F64](builtin-F64) val^

---

### min_normalised
<span class="source-link">[[Source]](src/builtin/float.md#L216)</span>


Minimum positive value representable at full precision (ie a normalised
number).


```pony
new val min_normalised()
: F64 val^
```

#### Returns

* [F64](builtin-F64) val^

---

### epsilon
<span class="source-link">[[Source]](src/builtin/float.md#L223)</span>


Minimum positive value such that (1 + epsilon) != 1.


```pony
new val epsilon()
: F64 val^
```

#### Returns

* [F64](builtin-F64) val^

---

## Public Functions

### bits
<span class="source-link">[[Source]](src/builtin/float.md#L201)</span>


```pony
fun box bits()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### radix
<span class="source-link">[[Source]](src/builtin/float.md#L229)</span>


Exponent radix.


```pony
fun tag radix()
: U8 val
```

#### Returns

* [U8](builtin-U8) val

---

### precision2
<span class="source-link">[[Source]](src/builtin/float.md#L235)</span>


Mantissa precision in bits.


```pony
fun tag precision2()
: U8 val
```

#### Returns

* [U8](builtin-U8) val

---

### precision10
<span class="source-link">[[Source]](src/builtin/float.md#L241)</span>


Mantissa precision in decimal digits.


```pony
fun tag precision10()
: U8 val
```

#### Returns

* [U8](builtin-U8) val

---

### min_exp2
<span class="source-link">[[Source]](src/builtin/float.md#L247)</span>


Minimum exponent value such that (2^exponent) - 1 is representable at full
precision (ie a normalised number).


```pony
fun tag min_exp2()
: I16 val
```

#### Returns

* [I16](builtin-I16) val

---

### min_exp10
<span class="source-link">[[Source]](src/builtin/float.md#L254)</span>


Minimum exponent value such that (10^exponent) - 1 is representable at full
precision (ie a normalised number).


```pony
fun tag min_exp10()
: I16 val
```

#### Returns

* [I16](builtin-I16) val

---

### max_exp2
<span class="source-link">[[Source]](src/builtin/float.md#L261)</span>


Maximum exponent value such that (2^exponent) - 1 is representable.


```pony
fun tag max_exp2()
: I16 val
```

#### Returns

* [I16](builtin-I16) val

---

### max_exp10
<span class="source-link">[[Source]](src/builtin/float.md#L267)</span>


Maximum exponent value such that (10^exponent) - 1 is representable.


```pony
fun tag max_exp10()
: I16 val
```

#### Returns

* [I16](builtin-I16) val

---

### abs
<span class="source-link">[[Source]](src/builtin/float.md#L273)</span>


```pony
fun box abs()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### ceil
<span class="source-link">[[Source]](src/builtin/float.md#L274)</span>


```pony
fun box ceil()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### floor
<span class="source-link">[[Source]](src/builtin/float.md#L275)</span>


```pony
fun box floor()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### round
<span class="source-link">[[Source]](src/builtin/float.md#L276)</span>


```pony
fun box round()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### trunc
<span class="source-link">[[Source]](src/builtin/float.md#L277)</span>


```pony
fun box trunc()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### min
<span class="source-link">[[Source]](src/builtin/float.md#L279)</span>


```pony
fun box min(
  y: F64 val)
: F64 val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [F64](builtin-F64) val

---

### max
<span class="source-link">[[Source]](src/builtin/float.md#L280)</span>


```pony
fun box max(
  y: F64 val)
: F64 val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [F64](builtin-F64) val

---

### finite
<span class="source-link">[[Source]](src/builtin/float.md#L282)</span>


Check whether this number is finite, ie not +/-infinity and not NaN.


```pony
fun box finite()
: Bool val
```

#### Returns

* [Bool](builtin-Bool) val

---

### infinite
<span class="source-link">[[Source]](src/builtin/float.md#L289)</span>


Check whether this number is +/-infinity


```pony
fun box infinite()
: Bool val
```

#### Returns

* [Bool](builtin-Bool) val

---

### nan
<span class="source-link">[[Source]](src/builtin/float.md#L297)</span>


Check whether this number is NaN.


```pony
fun box nan()
: Bool val
```

#### Returns

* [Bool](builtin-Bool) val

---

### ldexp
<span class="source-link">[[Source]](src/builtin/float.md#L305)</span>


```pony
fun box ldexp(
  x: F64 val,
  exponent: I32 val)
: F64 val
```
#### Parameters

*   x: [F64](builtin-F64) val
*   exponent: [I32](builtin-I32) val

#### Returns

* [F64](builtin-F64) val

---

### frexp
<span class="source-link">[[Source]](src/builtin/float.md#L308)</span>


```pony
fun box frexp()
: (F64 val , U32 val)
```

#### Returns

* ([F64](builtin-F64) val , [U32](builtin-U32) val)

---

### log
<span class="source-link">[[Source]](src/builtin/float.md#L313)</span>


```pony
fun box log()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### log2
<span class="source-link">[[Source]](src/builtin/float.md#L314)</span>


```pony
fun box log2()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### log10
<span class="source-link">[[Source]](src/builtin/float.md#L315)</span>


```pony
fun box log10()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### logb
<span class="source-link">[[Source]](src/builtin/float.md#L316)</span>


```pony
fun box logb()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### pow
<span class="source-link">[[Source]](src/builtin/float.md#L318)</span>


```pony
fun box pow(
  y: F64 val)
: F64 val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [F64](builtin-F64) val

---

### powi
<span class="source-link">[[Source]](src/builtin/float.md#L319)</span>


```pony
fun box powi(
  y: I32 val)
: F64 val
```
#### Parameters

*   y: [I32](builtin-I32) val

#### Returns

* [F64](builtin-F64) val

---

### sqrt
<span class="source-link">[[Source]](src/builtin/float.md#L326)</span>


```pony
fun box sqrt()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### sqrt_unsafe
<span class="source-link">[[Source]](src/builtin/float.md#L333)</span>


Unsafe operation.
If this is negative, the result is undefined.


```pony
fun box sqrt_unsafe()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### cbrt
<span class="source-link">[[Source]](src/builtin/float.md#L340)</span>


```pony
fun box cbrt()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### exp
<span class="source-link">[[Source]](src/builtin/float.md#L341)</span>


```pony
fun box exp()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### exp2
<span class="source-link">[[Source]](src/builtin/float.md#L342)</span>


```pony
fun box exp2()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### cos
<span class="source-link">[[Source]](src/builtin/float.md#L344)</span>


```pony
fun box cos()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### sin
<span class="source-link">[[Source]](src/builtin/float.md#L345)</span>


```pony
fun box sin()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### tan
<span class="source-link">[[Source]](src/builtin/float.md#L346)</span>


```pony
fun box tan()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### cosh
<span class="source-link">[[Source]](src/builtin/float.md#L348)</span>


```pony
fun box cosh()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### sinh
<span class="source-link">[[Source]](src/builtin/float.md#L349)</span>


```pony
fun box sinh()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### tanh
<span class="source-link">[[Source]](src/builtin/float.md#L350)</span>


```pony
fun box tanh()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### acos
<span class="source-link">[[Source]](src/builtin/float.md#L352)</span>


```pony
fun box acos()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### asin
<span class="source-link">[[Source]](src/builtin/float.md#L353)</span>


```pony
fun box asin()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### atan
<span class="source-link">[[Source]](src/builtin/float.md#L354)</span>


```pony
fun box atan()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### atan2
<span class="source-link">[[Source]](src/builtin/float.md#L355)</span>


```pony
fun box atan2(
  y: F64 val)
: F64 val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [F64](builtin-F64) val

---

### acosh
<span class="source-link">[[Source]](src/builtin/float.md#L357)</span>


```pony
fun box acosh()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### asinh
<span class="source-link">[[Source]](src/builtin/float.md#L358)</span>


```pony
fun box asinh()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### atanh
<span class="source-link">[[Source]](src/builtin/float.md#L359)</span>


```pony
fun box atanh()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### copysign
<span class="source-link">[[Source]](src/builtin/float.md#L361)</span>


```pony
fun box copysign(
  sign: F64 val)
: F64 val
```
#### Parameters

*   sign: [F64](builtin-F64) val

#### Returns

* [F64](builtin-F64) val

---

### hash
<span class="source-link">[[Source]](src/builtin/float.md#L363)</span>


```pony
fun box hash()
: USize val
```

#### Returns

* [USize](builtin-USize) val

---

### hash64
<span class="source-link">[[Source]](src/builtin/float.md#L364)</span>


```pony
fun box hash64()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### i128
<span class="source-link">[[Source]](src/builtin/float.md#L366)</span>


```pony
fun box i128()
: I128 val
```

#### Returns

* [I128](builtin-I128) val

---

### u128
<span class="source-link">[[Source]](src/builtin/float.md#L393)</span>


```pony
fun box u128()
: U128 val
```

#### Returns

* [U128](builtin-U128) val

---

### i128_unsafe
<span class="source-link">[[Source]](src/builtin/float.md#L419)</span>


Unsafe operation.
If the value doesn't fit in the destination type, the result is undefined.


```pony
fun box i128_unsafe()
: I128 val
```

#### Returns

* [I128](builtin-I128) val

---

### u128_unsafe
<span class="source-link">[[Source]](src/builtin/float.md#L426)</span>


Unsafe operation.
If the value doesn't fit in the destination type, the result is undefined.


```pony
fun box u128_unsafe()
: U128 val
```

#### Returns

* [U128](builtin-U128) val

---

### add_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L379)</span>


```pony
fun box add_unsafe(
  y: F64 val)
: F64 val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [F64](builtin-F64) val

---

### sub_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L388)</span>


```pony
fun box sub_unsafe(
  y: F64 val)
: F64 val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [F64](builtin-F64) val

---

### mul_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L397)</span>


```pony
fun box mul_unsafe(
  y: F64 val)
: F64 val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [F64](builtin-F64) val

---

### div_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L406)</span>


```pony
fun box div_unsafe(
  y: F64 val)
: F64 val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [F64](builtin-F64) val

---

### divmod_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L415)</span>


```pony
fun box divmod_unsafe(
  y: F64 val)
: (F64 val , F64 val)
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* ([F64](builtin-F64) val , [F64](builtin-F64) val)

---

### mod_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L424)</span>


```pony
fun box mod_unsafe(
  y: F64 val)
: F64 val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [F64](builtin-F64) val

---

### neg_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L433)</span>


```pony
fun box neg_unsafe()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### eq_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L442)</span>


```pony
fun box eq_unsafe(
  y: F64 val)
: Bool val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [Bool](builtin-Bool) val

---

### ne_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L451)</span>


```pony
fun box ne_unsafe(
  y: F64 val)
: Bool val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [Bool](builtin-Bool) val

---

### lt_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L460)</span>


```pony
fun box lt_unsafe(
  y: F64 val)
: Bool val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [Bool](builtin-Bool) val

---

### le_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L469)</span>


```pony
fun box le_unsafe(
  y: F64 val)
: Bool val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [Bool](builtin-Bool) val

---

### ge_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L478)</span>


```pony
fun box ge_unsafe(
  y: F64 val)
: Bool val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [Bool](builtin-Bool) val

---

### gt_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L487)</span>


```pony
fun box gt_unsafe(
  y: F64 val)
: Bool val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [Bool](builtin-Bool) val

---

### string
<span class="source-link">[[Source]](src/builtin/real.md#L547)</span>


```pony
fun box string()
: String iso^
```

#### Returns

* [String](builtin-String) iso^

---

### add
<span class="source-link">[[Source]](src/builtin/real.md#L141)</span>


```pony
fun box add(
  y: F64 val)
: F64 val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [F64](builtin-F64) val

---

### sub
<span class="source-link">[[Source]](src/builtin/real.md#L142)</span>


```pony
fun box sub(
  y: F64 val)
: F64 val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [F64](builtin-F64) val

---

### mul
<span class="source-link">[[Source]](src/builtin/real.md#L143)</span>


```pony
fun box mul(
  y: F64 val)
: F64 val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [F64](builtin-F64) val

---

### div
<span class="source-link">[[Source]](src/builtin/real.md#L144)</span>


```pony
fun box div(
  y: F64 val)
: F64 val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [F64](builtin-F64) val

---

### divmod
<span class="source-link">[[Source]](src/builtin/real.md#L145)</span>


```pony
fun box divmod(
  y: F64 val)
: (F64 val , F64 val)
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* ([F64](builtin-F64) val , [F64](builtin-F64) val)

---

### mod
<span class="source-link">[[Source]](src/builtin/real.md#L146)</span>


```pony
fun box mod(
  y: F64 val)
: F64 val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [F64](builtin-F64) val

---

### neg
<span class="source-link">[[Source]](src/builtin/real.md#L147)</span>


```pony
fun box neg()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### eq
<span class="source-link">[[Source]](src/builtin/real.md#L149)</span>


```pony
fun box eq(
  y: F64 val)
: Bool val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [Bool](builtin-Bool) val

---

### ne
<span class="source-link">[[Source]](src/builtin/real.md#L150)</span>


```pony
fun box ne(
  y: F64 val)
: Bool val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [Bool](builtin-Bool) val

---

### lt
<span class="source-link">[[Source]](src/builtin/real.md#L151)</span>


```pony
fun box lt(
  y: F64 val)
: Bool val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [Bool](builtin-Bool) val

---

### le
<span class="source-link">[[Source]](src/builtin/real.md#L152)</span>


```pony
fun box le(
  y: F64 val)
: Bool val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [Bool](builtin-Bool) val

---

### ge
<span class="source-link">[[Source]](src/builtin/real.md#L153)</span>


```pony
fun box ge(
  y: F64 val)
: Bool val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [Bool](builtin-Bool) val

---

### gt
<span class="source-link">[[Source]](src/builtin/real.md#L154)</span>


```pony
fun box gt(
  y: F64 val)
: Bool val
```
#### Parameters

*   y: [F64](builtin-F64) val

#### Returns

* [Bool](builtin-Bool) val

---

### i8
<span class="source-link">[[Source]](src/builtin/real.md#L2)</span>


```pony
fun box i8()
: I8 val
```

#### Returns

* [I8](builtin-I8) val

---

### i16
<span class="source-link">[[Source]](src/builtin/real.md#L3)</span>


```pony
fun box i16()
: I16 val
```

#### Returns

* [I16](builtin-I16) val

---

### i32
<span class="source-link">[[Source]](src/builtin/real.md#L4)</span>


```pony
fun box i32()
: I32 val
```

#### Returns

* [I32](builtin-I32) val

---

### i64
<span class="source-link">[[Source]](src/builtin/real.md#L5)</span>


```pony
fun box i64()
: I64 val
```

#### Returns

* [I64](builtin-I64) val

---

### ilong
<span class="source-link">[[Source]](src/builtin/real.md#L7)</span>


```pony
fun box ilong()
: ILong val
```

#### Returns

* [ILong](builtin-ILong) val

---

### isize
<span class="source-link">[[Source]](src/builtin/real.md#L8)</span>


```pony
fun box isize()
: ISize val
```

#### Returns

* [ISize](builtin-ISize) val

---

### u8
<span class="source-link">[[Source]](src/builtin/real.md#L10)</span>


```pony
fun box u8()
: U8 val
```

#### Returns

* [U8](builtin-U8) val

---

### u16
<span class="source-link">[[Source]](src/builtin/real.md#L11)</span>


```pony
fun box u16()
: U16 val
```

#### Returns

* [U16](builtin-U16) val

---

### u32
<span class="source-link">[[Source]](src/builtin/real.md#L12)</span>


```pony
fun box u32()
: U32 val
```

#### Returns

* [U32](builtin-U32) val

---

### u64
<span class="source-link">[[Source]](src/builtin/real.md#L13)</span>


```pony
fun box u64()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### ulong
<span class="source-link">[[Source]](src/builtin/real.md#L15)</span>


```pony
fun box ulong()
: ULong val
```

#### Returns

* [ULong](builtin-ULong) val

---

### usize
<span class="source-link">[[Source]](src/builtin/real.md#L16)</span>


```pony
fun box usize()
: USize val
```

#### Returns

* [USize](builtin-USize) val

---

### f32
<span class="source-link">[[Source]](src/builtin/real.md#L18)</span>


```pony
fun box f32()
: F32 val
```

#### Returns

* [F32](builtin-F32) val

---

### f64
<span class="source-link">[[Source]](src/builtin/real.md#L19)</span>


```pony
fun box f64()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### i8_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L21)</span>


```pony
fun box i8_unsafe()
: I8 val
```

#### Returns

* [I8](builtin-I8) val

---

### i16_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L28)</span>


```pony
fun box i16_unsafe()
: I16 val
```

#### Returns

* [I16](builtin-I16) val

---

### i32_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L35)</span>


```pony
fun box i32_unsafe()
: I32 val
```

#### Returns

* [I32](builtin-I32) val

---

### i64_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L42)</span>


```pony
fun box i64_unsafe()
: I64 val
```

#### Returns

* [I64](builtin-I64) val

---

### ilong_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L56)</span>


```pony
fun box ilong_unsafe()
: ILong val
```

#### Returns

* [ILong](builtin-ILong) val

---

### isize_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L63)</span>


```pony
fun box isize_unsafe()
: ISize val
```

#### Returns

* [ISize](builtin-ISize) val

---

### u8_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L70)</span>


```pony
fun box u8_unsafe()
: U8 val
```

#### Returns

* [U8](builtin-U8) val

---

### u16_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L77)</span>


```pony
fun box u16_unsafe()
: U16 val
```

#### Returns

* [U16](builtin-U16) val

---

### u32_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L84)</span>


```pony
fun box u32_unsafe()
: U32 val
```

#### Returns

* [U32](builtin-U32) val

---

### u64_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L91)</span>


```pony
fun box u64_unsafe()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### ulong_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L105)</span>


```pony
fun box ulong_unsafe()
: ULong val
```

#### Returns

* [ULong](builtin-ULong) val

---

### usize_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L112)</span>


```pony
fun box usize_unsafe()
: USize val
```

#### Returns

* [USize](builtin-USize) val

---

### f32_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L119)</span>


```pony
fun box f32_unsafe()
: F32 val
```

#### Returns

* [F32](builtin-F32) val

---

### f64_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L126)</span>


```pony
fun box f64_unsafe()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### compare



```pony
fun box compare(
  that: F64 val)
: (Less val | Equal val | Greater val)
```
#### Parameters

*   that: [F64](builtin-F64) val

#### Returns

* ([Less](builtin-Less) val | [Equal](builtin-Equal) val | [Greater](builtin-Greater) val)

---

## Private Functions

### _value
<span class="source-link">[[Source]](src/builtin/real.md#L188)</span>


```pony
fun box _value()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

