# FloatingPoint\[A: [FloatingPoint](builtin-FloatingPoint)\[A\] val\]
<span class="source-link">[[Source]](src/builtin/real.md#L368)</span>
```pony
trait val FloatingPoint[A: FloatingPoint[A] val] is
  Real[A] val
```

#### Implements

* [Real](builtin-Real)\[A\] val

---

## Constructors

### min_normalised
<span class="source-link">[[Source]](src/builtin/real.md#L369)</span>


```pony
new val min_normalised()
: FloatingPoint[A] val^
```

#### Returns

* [FloatingPoint](builtin-FloatingPoint)\[A\] val^

---

### epsilon
<span class="source-link">[[Source]](src/builtin/real.md#L370)</span>


```pony
new val epsilon()
: FloatingPoint[A] val^
```

#### Returns

* [FloatingPoint](builtin-FloatingPoint)\[A\] val^

---

### create
<span class="source-link">[[Source]](src/builtin/real.md#L135)</span>


```pony
new val create(
  value: A)
: Real[A] val^
```
#### Parameters

*   value: A

#### Returns

* [Real](builtin-Real)\[A\] val^

---

### from\[B: (([I8](builtin-I8) val | [I16](builtin-I16) val | [I32](builtin-I32) val | [I64](builtin-I64) val | [I128](builtin-I128) val | [ILong](builtin-ILong) val | [ISize](builtin-ISize) val | [U8](builtin-U8) val | [U16](builtin-U16) val | [U32](builtin-U32) val | [U64](builtin-U64) val | [U128](builtin-U128) val | [ULong](builtin-ULong) val | [USize](builtin-USize) val | [F32](builtin-F32) val | [F64](builtin-F64) val) & [Real](builtin-Real)\[B\] val)\]
<span class="source-link">[[Source]](src/builtin/real.md#L137)</span>


```pony
new val from[B: ((I8 val | I16 val | I32 val | 
    I64 val | I128 val | ILong val | 
    ISize val | U8 val | U16 val | 
    U32 val | U64 val | U128 val | 
    ULong val | USize val | F32 val | 
    F64 val) & Real[B] val)](
  a: B)
: Real[A] val^
```
#### Parameters

*   a: B

#### Returns

* [Real](builtin-Real)\[A\] val^

---

### min_value
<span class="source-link">[[Source]](src/builtin/real.md#L138)</span>


```pony
new val min_value()
: Real[A] val^
```

#### Returns

* [Real](builtin-Real)\[A\] val^

---

### max_value
<span class="source-link">[[Source]](src/builtin/real.md#L139)</span>


```pony
new val max_value()
: Real[A] val^
```

#### Returns

* [Real](builtin-Real)\[A\] val^

---

## Public Functions

### radix
<span class="source-link">[[Source]](src/builtin/real.md#L371)</span>


```pony
fun tag radix()
: U8 val
```

#### Returns

* [U8](builtin-U8) val

---

### precision2
<span class="source-link">[[Source]](src/builtin/real.md#L372)</span>


```pony
fun tag precision2()
: U8 val
```

#### Returns

* [U8](builtin-U8) val

---

### precision10
<span class="source-link">[[Source]](src/builtin/real.md#L373)</span>


```pony
fun tag precision10()
: U8 val
```

#### Returns

* [U8](builtin-U8) val

---

### min_exp2
<span class="source-link">[[Source]](src/builtin/real.md#L374)</span>


```pony
fun tag min_exp2()
: I16 val
```

#### Returns

* [I16](builtin-I16) val

---

### min_exp10
<span class="source-link">[[Source]](src/builtin/real.md#L375)</span>


```pony
fun tag min_exp10()
: I16 val
```

#### Returns

* [I16](builtin-I16) val

---

### max_exp2
<span class="source-link">[[Source]](src/builtin/real.md#L376)</span>


```pony
fun tag max_exp2()
: I16 val
```

#### Returns

* [I16](builtin-I16) val

---

### max_exp10
<span class="source-link">[[Source]](src/builtin/real.md#L377)</span>


```pony
fun tag max_exp10()
: I16 val
```

#### Returns

* [I16](builtin-I16) val

---

### add_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L379)</span>


Unsafe operation.
If any input or output of the operation is +/- infinity or NaN, the result
is undefined.
The operation isn't required to fully comply to IEEE 754 semantics.


```pony
fun box add_unsafe(
  y: A)
: A
```
#### Parameters

*   y: A

#### Returns

* A

---

### sub_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L388)</span>


Unsafe operation.
If any input or output of the operation is +/- infinity or NaN, the result
is undefined.
The operation isn't required to fully comply to IEEE 754 semantics.


```pony
fun box sub_unsafe(
  y: A)
: A
```
#### Parameters

*   y: A

#### Returns

* A

---

### mul_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L397)</span>


Unsafe operation.
If any input or output of the operation is +/- infinity or NaN, the result
is undefined.
The operation isn't required to fully comply to IEEE 754 semantics.


```pony
fun box mul_unsafe(
  y: A)
: A
```
#### Parameters

*   y: A

#### Returns

* A

---

### div_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L406)</span>


Unsafe operation.
If any input or output of the operation is +/- infinity or NaN, the result
is undefined.
The operation isn't required to fully comply to IEEE 754 semantics.


```pony
fun box div_unsafe(
  y: A)
: A
```
#### Parameters

*   y: A

#### Returns

* A

---

### divmod_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L415)</span>


Unsafe operation.
If any input or output of the operation is +/- infinity or NaN, the result
is undefined.
The operation isn't required to fully comply to IEEE 754 semantics.


```pony
fun box divmod_unsafe(
  y: A)
: (A , A)
```
#### Parameters

*   y: A

#### Returns

* (A , A)

---

### mod_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L424)</span>


Unsafe operation.
If any input or output of the operation is +/- infinity or NaN, the result
is undefined.
The operation isn't required to fully comply to IEEE 754 semantics.


```pony
fun box mod_unsafe(
  y: A)
: A
```
#### Parameters

*   y: A

#### Returns

* A

---

### neg_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L433)</span>


Unsafe operation.
If any input or output of the operation is +/- infinity or NaN, the result
is undefined.
The operation isn't required to fully comply to IEEE 754 semantics.


```pony
fun box neg_unsafe()
: A
```

#### Returns

* A

---

### eq_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L442)</span>


Unsafe operation.
If any input of the operation is +/- infinity or NaN, the result is
undefined.
The operation isn't required to fully comply to IEEE 754 semantics.


```pony
fun box eq_unsafe(
  y: box->A)
: Bool val
```
#### Parameters

*   y: box->A

#### Returns

* [Bool](builtin-Bool) val

---

### ne_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L451)</span>


Unsafe operation.
If any input of the operation is +/- infinity or NaN, the result is
undefined.
The operation isn't required to fully comply to IEEE 754 semantics.


```pony
fun box ne_unsafe(
  y: box->A)
: Bool val
```
#### Parameters

*   y: box->A

#### Returns

* [Bool](builtin-Bool) val

---

### lt_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L460)</span>


Unsafe operation.
If any input of the operation is +/- infinity or NaN, the result is
undefined.
The operation isn't required to fully comply to IEEE 754 semantics.


```pony
fun box lt_unsafe(
  y: box->A)
: Bool val
```
#### Parameters

*   y: box->A

#### Returns

* [Bool](builtin-Bool) val

---

### le_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L469)</span>


Unsafe operation.
If any input of the operation is +/- infinity or NaN, the result is
undefined.
The operation isn't required to fully comply to IEEE 754 semantics.


```pony
fun box le_unsafe(
  y: box->A)
: Bool val
```
#### Parameters

*   y: box->A

#### Returns

* [Bool](builtin-Bool) val

---

### ge_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L478)</span>


Unsafe operation.
If any input of the operation is +/- infinity or NaN, the result is
undefined.
The operation isn't required to fully comply to IEEE 754 semantics.


```pony
fun box ge_unsafe(
  y: box->A)
: Bool val
```
#### Parameters

*   y: box->A

#### Returns

* [Bool](builtin-Bool) val

---

### gt_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L487)</span>


Unsafe operation.
If any input of the operation is +/- infinity or NaN, the result is
undefined.
The operation isn't required to fully comply to IEEE 754 semantics.


```pony
fun box gt_unsafe(
  y: box->A)
: Bool val
```
#### Parameters

*   y: box->A

#### Returns

* [Bool](builtin-Bool) val

---

### abs
<span class="source-link">[[Source]](src/builtin/real.md#L496)</span>


```pony
fun box abs()
: A
```

#### Returns

* A

---

### ceil
<span class="source-link">[[Source]](src/builtin/real.md#L497)</span>


```pony
fun box ceil()
: A
```

#### Returns

* A

---

### floor
<span class="source-link">[[Source]](src/builtin/real.md#L498)</span>


```pony
fun box floor()
: A
```

#### Returns

* A

---

### round
<span class="source-link">[[Source]](src/builtin/real.md#L499)</span>


```pony
fun box round()
: A
```

#### Returns

* A

---

### trunc
<span class="source-link">[[Source]](src/builtin/real.md#L500)</span>


```pony
fun box trunc()
: A
```

#### Returns

* A

---

### finite
<span class="source-link">[[Source]](src/builtin/real.md#L502)</span>


```pony
fun box finite()
: Bool val
```

#### Returns

* [Bool](builtin-Bool) val

---

### infinite
<span class="source-link">[[Source]](src/builtin/real.md#L503)</span>


```pony
fun box infinite()
: Bool val
```

#### Returns

* [Bool](builtin-Bool) val

---

### nan
<span class="source-link">[[Source]](src/builtin/real.md#L504)</span>


```pony
fun box nan()
: Bool val
```

#### Returns

* [Bool](builtin-Bool) val

---

### ldexp
<span class="source-link">[[Source]](src/builtin/real.md#L506)</span>


```pony
fun box ldexp(
  x: A,
  exponent: I32 val)
: A
```
#### Parameters

*   x: A
*   exponent: [I32](builtin-I32) val

#### Returns

* A

---

### frexp
<span class="source-link">[[Source]](src/builtin/real.md#L507)</span>


```pony
fun box frexp()
: (A , U32 val)
```

#### Returns

* (A , [U32](builtin-U32) val)

---

### log
<span class="source-link">[[Source]](src/builtin/real.md#L508)</span>


```pony
fun box log()
: A
```

#### Returns

* A

---

### log2
<span class="source-link">[[Source]](src/builtin/real.md#L509)</span>


```pony
fun box log2()
: A
```

#### Returns

* A

---

### log10
<span class="source-link">[[Source]](src/builtin/real.md#L510)</span>


```pony
fun box log10()
: A
```

#### Returns

* A

---

### logb
<span class="source-link">[[Source]](src/builtin/real.md#L511)</span>


```pony
fun box logb()
: A
```

#### Returns

* A

---

### pow
<span class="source-link">[[Source]](src/builtin/real.md#L513)</span>


```pony
fun box pow(
  y: A)
: A
```
#### Parameters

*   y: A

#### Returns

* A

---

### powi
<span class="source-link">[[Source]](src/builtin/real.md#L514)</span>


```pony
fun box powi(
  y: I32 val)
: A
```
#### Parameters

*   y: [I32](builtin-I32) val

#### Returns

* A

---

### sqrt
<span class="source-link">[[Source]](src/builtin/real.md#L516)</span>


```pony
fun box sqrt()
: A
```

#### Returns

* A

---

### sqrt_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L518)</span>


Unsafe operation.
If this is negative, the result is undefined.


```pony
fun box sqrt_unsafe()
: A
```

#### Returns

* A

---

### cbrt
<span class="source-link">[[Source]](src/builtin/real.md#L524)</span>


```pony
fun box cbrt()
: A
```

#### Returns

* A

---

### exp
<span class="source-link">[[Source]](src/builtin/real.md#L525)</span>


```pony
fun box exp()
: A
```

#### Returns

* A

---

### exp2
<span class="source-link">[[Source]](src/builtin/real.md#L526)</span>


```pony
fun box exp2()
: A
```

#### Returns

* A

---

### cos
<span class="source-link">[[Source]](src/builtin/real.md#L528)</span>


```pony
fun box cos()
: A
```

#### Returns

* A

---

### sin
<span class="source-link">[[Source]](src/builtin/real.md#L529)</span>


```pony
fun box sin()
: A
```

#### Returns

* A

---

### tan
<span class="source-link">[[Source]](src/builtin/real.md#L530)</span>


```pony
fun box tan()
: A
```

#### Returns

* A

---

### cosh
<span class="source-link">[[Source]](src/builtin/real.md#L532)</span>


```pony
fun box cosh()
: A
```

#### Returns

* A

---

### sinh
<span class="source-link">[[Source]](src/builtin/real.md#L533)</span>


```pony
fun box sinh()
: A
```

#### Returns

* A

---

### tanh
<span class="source-link">[[Source]](src/builtin/real.md#L534)</span>


```pony
fun box tanh()
: A
```

#### Returns

* A

---

### acos
<span class="source-link">[[Source]](src/builtin/real.md#L536)</span>


```pony
fun box acos()
: A
```

#### Returns

* A

---

### asin
<span class="source-link">[[Source]](src/builtin/real.md#L537)</span>


```pony
fun box asin()
: A
```

#### Returns

* A

---

### atan
<span class="source-link">[[Source]](src/builtin/real.md#L538)</span>


```pony
fun box atan()
: A
```

#### Returns

* A

---

### atan2
<span class="source-link">[[Source]](src/builtin/real.md#L539)</span>


```pony
fun box atan2(
  y: A)
: A
```
#### Parameters

*   y: A

#### Returns

* A

---

### acosh
<span class="source-link">[[Source]](src/builtin/real.md#L541)</span>


```pony
fun box acosh()
: A
```

#### Returns

* A

---

### asinh
<span class="source-link">[[Source]](src/builtin/real.md#L542)</span>


```pony
fun box asinh()
: A
```

#### Returns

* A

---

### atanh
<span class="source-link">[[Source]](src/builtin/real.md#L543)</span>


```pony
fun box atanh()
: A
```

#### Returns

* A

---

### copysign
<span class="source-link">[[Source]](src/builtin/real.md#L545)</span>


```pony
fun box copysign(
  sign: A)
: A
```
#### Parameters

*   sign: A

#### Returns

* A

---

### string
<span class="source-link">[[Source]](src/builtin/real.md#L547)</span>


```pony
fun box string()
: String iso^
```

#### Returns

* [String](builtin-String) iso^

---

### add
<span class="source-link">[[Source]](src/builtin/real.md#L141)</span>


```pony
fun box add(
  y: A)
: A
```
#### Parameters

*   y: A

#### Returns

* A

---

### sub
<span class="source-link">[[Source]](src/builtin/real.md#L142)</span>


```pony
fun box sub(
  y: A)
: A
```
#### Parameters

*   y: A

#### Returns

* A

---

### mul
<span class="source-link">[[Source]](src/builtin/real.md#L143)</span>


```pony
fun box mul(
  y: A)
: A
```
#### Parameters

*   y: A

#### Returns

* A

---

### div
<span class="source-link">[[Source]](src/builtin/real.md#L144)</span>


```pony
fun box div(
  y: A)
: A
```
#### Parameters

*   y: A

#### Returns

* A

---

### divmod
<span class="source-link">[[Source]](src/builtin/real.md#L145)</span>


```pony
fun box divmod(
  y: A)
: (A , A)
```
#### Parameters

*   y: A

#### Returns

* (A , A)

---

### mod
<span class="source-link">[[Source]](src/builtin/real.md#L146)</span>


```pony
fun box mod(
  y: A)
: A
```
#### Parameters

*   y: A

#### Returns

* A

---

### neg
<span class="source-link">[[Source]](src/builtin/real.md#L147)</span>


```pony
fun box neg()
: A
```

#### Returns

* A

---

### eq
<span class="source-link">[[Source]](src/builtin/real.md#L149)</span>


```pony
fun box eq(
  y: box->A)
: Bool val
```
#### Parameters

*   y: box->A

#### Returns

* [Bool](builtin-Bool) val

---

### ne
<span class="source-link">[[Source]](src/builtin/real.md#L150)</span>


```pony
fun box ne(
  y: box->A)
: Bool val
```
#### Parameters

*   y: box->A

#### Returns

* [Bool](builtin-Bool) val

---

### lt
<span class="source-link">[[Source]](src/builtin/real.md#L151)</span>


```pony
fun box lt(
  y: box->A)
: Bool val
```
#### Parameters

*   y: box->A

#### Returns

* [Bool](builtin-Bool) val

---

### le
<span class="source-link">[[Source]](src/builtin/real.md#L152)</span>


```pony
fun box le(
  y: box->A)
: Bool val
```
#### Parameters

*   y: box->A

#### Returns

* [Bool](builtin-Bool) val

---

### ge
<span class="source-link">[[Source]](src/builtin/real.md#L153)</span>


```pony
fun box ge(
  y: box->A)
: Bool val
```
#### Parameters

*   y: box->A

#### Returns

* [Bool](builtin-Bool) val

---

### gt
<span class="source-link">[[Source]](src/builtin/real.md#L154)</span>


```pony
fun box gt(
  y: box->A)
: Bool val
```
#### Parameters

*   y: box->A

#### Returns

* [Bool](builtin-Bool) val

---

### min
<span class="source-link">[[Source]](src/builtin/real.md#L156)</span>


```pony
fun box min(
  y: A)
: A
```
#### Parameters

*   y: A

#### Returns

* A

---

### max
<span class="source-link">[[Source]](src/builtin/real.md#L157)</span>


```pony
fun box max(
  y: A)
: A
```
#### Parameters

*   y: A

#### Returns

* A

---

### hash
<span class="source-link">[[Source]](src/builtin/real.md#L159)</span>


```pony
fun box hash()
: USize val
```

#### Returns

* [USize](builtin-USize) val

---

### hash64
<span class="source-link">[[Source]](src/builtin/real.md#L175)</span>


```pony
fun box hash64()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### i8
<span class="source-link">[[Source]](src/builtin/real.md#L2)</span>


```pony
fun box i8()
: I8 val
```

#### Returns

* [I8](builtin-I8) val

---

### i16
<span class="source-link">[[Source]](src/builtin/real.md#L3)</span>


```pony
fun box i16()
: I16 val
```

#### Returns

* [I16](builtin-I16) val

---

### i32
<span class="source-link">[[Source]](src/builtin/real.md#L4)</span>


```pony
fun box i32()
: I32 val
```

#### Returns

* [I32](builtin-I32) val

---

### i64
<span class="source-link">[[Source]](src/builtin/real.md#L5)</span>


```pony
fun box i64()
: I64 val
```

#### Returns

* [I64](builtin-I64) val

---

### i128
<span class="source-link">[[Source]](src/builtin/real.md#L6)</span>


```pony
fun box i128()
: I128 val
```

#### Returns

* [I128](builtin-I128) val

---

### ilong
<span class="source-link">[[Source]](src/builtin/real.md#L7)</span>


```pony
fun box ilong()
: ILong val
```

#### Returns

* [ILong](builtin-ILong) val

---

### isize
<span class="source-link">[[Source]](src/builtin/real.md#L8)</span>


```pony
fun box isize()
: ISize val
```

#### Returns

* [ISize](builtin-ISize) val

---

### u8
<span class="source-link">[[Source]](src/builtin/real.md#L10)</span>


```pony
fun box u8()
: U8 val
```

#### Returns

* [U8](builtin-U8) val

---

### u16
<span class="source-link">[[Source]](src/builtin/real.md#L11)</span>


```pony
fun box u16()
: U16 val
```

#### Returns

* [U16](builtin-U16) val

---

### u32
<span class="source-link">[[Source]](src/builtin/real.md#L12)</span>


```pony
fun box u32()
: U32 val
```

#### Returns

* [U32](builtin-U32) val

---

### u64
<span class="source-link">[[Source]](src/builtin/real.md#L13)</span>


```pony
fun box u64()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### u128
<span class="source-link">[[Source]](src/builtin/real.md#L14)</span>


```pony
fun box u128()
: U128 val
```

#### Returns

* [U128](builtin-U128) val

---

### ulong
<span class="source-link">[[Source]](src/builtin/real.md#L15)</span>


```pony
fun box ulong()
: ULong val
```

#### Returns

* [ULong](builtin-ULong) val

---

### usize
<span class="source-link">[[Source]](src/builtin/real.md#L16)</span>


```pony
fun box usize()
: USize val
```

#### Returns

* [USize](builtin-USize) val

---

### f32
<span class="source-link">[[Source]](src/builtin/real.md#L18)</span>


```pony
fun box f32()
: F32 val
```

#### Returns

* [F32](builtin-F32) val

---

### f64
<span class="source-link">[[Source]](src/builtin/real.md#L19)</span>


```pony
fun box f64()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### i8_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L21)</span>


```pony
fun box i8_unsafe()
: I8 val
```

#### Returns

* [I8](builtin-I8) val

---

### i16_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L28)</span>


```pony
fun box i16_unsafe()
: I16 val
```

#### Returns

* [I16](builtin-I16) val

---

### i32_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L35)</span>


```pony
fun box i32_unsafe()
: I32 val
```

#### Returns

* [I32](builtin-I32) val

---

### i64_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L42)</span>


```pony
fun box i64_unsafe()
: I64 val
```

#### Returns

* [I64](builtin-I64) val

---

### i128_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L49)</span>


```pony
fun box i128_unsafe()
: I128 val
```

#### Returns

* [I128](builtin-I128) val

---

### ilong_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L56)</span>


```pony
fun box ilong_unsafe()
: ILong val
```

#### Returns

* [ILong](builtin-ILong) val

---

### isize_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L63)</span>


```pony
fun box isize_unsafe()
: ISize val
```

#### Returns

* [ISize](builtin-ISize) val

---

### u8_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L70)</span>


```pony
fun box u8_unsafe()
: U8 val
```

#### Returns

* [U8](builtin-U8) val

---

### u16_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L77)</span>


```pony
fun box u16_unsafe()
: U16 val
```

#### Returns

* [U16](builtin-U16) val

---

### u32_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L84)</span>


```pony
fun box u32_unsafe()
: U32 val
```

#### Returns

* [U32](builtin-U32) val

---

### u64_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L91)</span>


```pony
fun box u64_unsafe()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### u128_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L98)</span>


```pony
fun box u128_unsafe()
: U128 val
```

#### Returns

* [U128](builtin-U128) val

---

### ulong_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L105)</span>


```pony
fun box ulong_unsafe()
: ULong val
```

#### Returns

* [ULong](builtin-ULong) val

---

### usize_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L112)</span>


```pony
fun box usize_unsafe()
: USize val
```

#### Returns

* [USize](builtin-USize) val

---

### f32_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L119)</span>


```pony
fun box f32_unsafe()
: F32 val
```

#### Returns

* [F32](builtin-F32) val

---

### f64_unsafe
<span class="source-link">[[Source]](src/builtin/real.md#L126)</span>


```pony
fun box f64_unsafe()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### compare



```pony
fun box compare(
  that: box->A)
: (Less val | Equal val | Greater val)
```
#### Parameters

*   that: box->A

#### Returns

* ([Less](builtin-Less) val | [Equal](builtin-Equal) val | [Greater](builtin-Greater) val)

---

## Private Functions

### _value
<span class="source-link">[[Source]](src/builtin/real.md#L188)</span>


```pony
fun box _value()
: A
```

#### Returns

* A

---

