# U64
<span class="source-link">[[Source]](src/builtin/unsigned.md#L136)</span>
```pony
primitive val U64 is
  _UnsignedInteger[U64 val] val
```

#### Implements

* [_UnsignedInteger](builtin-_UnsignedInteger)\[[U64](builtin-U64) val\] val

---

## Constructors

### create
<span class="source-link">[[Source]](src/builtin/unsigned.md#L137)</span>


```pony
new val create(
  value: U64 val)
: U64 val^
```
#### Parameters

*   value: [U64](builtin-U64) val

#### Returns

* [U64](builtin-U64) val^

---

### from\[A: (([I8](builtin-I8) val | [I16](builtin-I16) val | [I32](builtin-I32) val | [I64](builtin-I64) val | [I128](builtin-I128) val | [ILong](builtin-ILong) val | [ISize](builtin-ISize) val | [U8](builtin-U8) val | [U16](builtin-U16) val | [U32](builtin-U32) val | [U64](builtin-U64) val | [U128](builtin-U128) val | [ULong](builtin-ULong) val | [USize](builtin-USize) val | [F32](builtin-F32) val | [F64](builtin-F64) val) & [Real](builtin-Real)\[A\] val)\]
<span class="source-link">[[Source]](src/builtin/unsigned.md#L138)</span>


```pony
new val from[A: ((I8 val | I16 val | I32 val | 
    I64 val | I128 val | ILong val | 
    ISize val | U8 val | U16 val | 
    U32 val | U64 val | U128 val | 
    ULong val | USize val | F32 val | 
    F64 val) & Real[A] val)](
  a: A)
: U64 val^
```
#### Parameters

*   a: A

#### Returns

* [U64](builtin-U64) val^

---

### min_value
<span class="source-link">[[Source]](src/builtin/unsigned.md#L140)</span>


```pony
new val min_value()
: U64 val^
```

#### Returns

* [U64](builtin-U64) val^

---

### max_value
<span class="source-link">[[Source]](src/builtin/unsigned.md#L141)</span>


```pony
new val max_value()
: U64 val^
```

#### Returns

* [U64](builtin-U64) val^

---

## Public Functions

### next_pow2
<span class="source-link">[[Source]](src/builtin/unsigned.md#L143)</span>


```pony
fun box next_pow2()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### abs
<span class="source-link">[[Source]](src/builtin/unsigned.md#L147)</span>


```pony
fun box abs()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### bit_reverse
<span class="source-link">[[Source]](src/builtin/unsigned.md#L148)</span>


```pony
fun box bit_reverse()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### bswap
<span class="source-link">[[Source]](src/builtin/unsigned.md#L149)</span>


```pony
fun box bswap()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### popcount
<span class="source-link">[[Source]](src/builtin/unsigned.md#L150)</span>


```pony
fun box popcount()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### clz
<span class="source-link">[[Source]](src/builtin/unsigned.md#L151)</span>


```pony
fun box clz()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### ctz
<span class="source-link">[[Source]](src/builtin/unsigned.md#L152)</span>


```pony
fun box ctz()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### clz_unsafe
<span class="source-link">[[Source]](src/builtin/unsigned.md#L154)</span>


Unsafe operation.
If this is 0, the result is undefined.


```pony
fun box clz_unsafe()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### ctz_unsafe
<span class="source-link">[[Source]](src/builtin/unsigned.md#L161)</span>


Unsafe operation.
If this is 0, the result is undefined.


```pony
fun box ctz_unsafe()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### bitwidth
<span class="source-link">[[Source]](src/builtin/unsigned.md#L168)</span>


```pony
fun box bitwidth()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### min
<span class="source-link">[[Source]](src/builtin/unsigned.md#L169)</span>


```pony
fun box min(
  y: U64 val)
: U64 val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [U64](builtin-U64) val

---

### max
<span class="source-link">[[Source]](src/builtin/unsigned.md#L170)</span>


```pony
fun box max(
  y: U64 val)
: U64 val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [U64](builtin-U64) val

---

### hash
<span class="source-link">[[Source]](src/builtin/unsigned.md#L172)</span>


```pony
fun box hash()
: USize val
```

#### Returns

* [USize](builtin-USize) val

---

### addc
<span class="source-link">[[Source]](src/builtin/unsigned.md#L179)</span>


```pony
fun box addc(
  y: U64 val)
: (U64 val , Bool val)
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* ([U64](builtin-U64) val , [Bool](builtin-Bool) val)

---

### subc
<span class="source-link">[[Source]](src/builtin/unsigned.md#L182)</span>


```pony
fun box subc(
  y: U64 val)
: (U64 val , Bool val)
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* ([U64](builtin-U64) val , [Bool](builtin-Bool) val)

---

### mulc
<span class="source-link">[[Source]](src/builtin/unsigned.md#L185)</span>


```pony
fun box mulc(
  y: U64 val)
: (U64 val , Bool val)
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* ([U64](builtin-U64) val , [Bool](builtin-Bool) val)

---

### shl



```pony
fun box shl(
  y: U64 val)
: U64 val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [U64](builtin-U64) val

---

### shr



```pony
fun box shr(
  y: U64 val)
: U64 val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [U64](builtin-U64) val

---

### shl_unsafe



```pony
fun box shl_unsafe(
  y: U64 val)
: U64 val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [U64](builtin-U64) val

---

### shr_unsafe



```pony
fun box shr_unsafe(
  y: U64 val)
: U64 val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [U64](builtin-U64) val

---

### rotl



```pony
fun box rotl(
  y: U64 val)
: U64 val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [U64](builtin-U64) val

---

### rotr



```pony
fun box rotr(
  y: U64 val)
: U64 val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [U64](builtin-U64) val

---

### string



```pony
fun box string()
: String iso^
```

#### Returns

* [String](builtin-String) iso^

---

### add_unsafe



```pony
fun box add_unsafe(
  y: U64 val)
: U64 val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [U64](builtin-U64) val

---

### sub_unsafe



```pony
fun box sub_unsafe(
  y: U64 val)
: U64 val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [U64](builtin-U64) val

---

### mul_unsafe



```pony
fun box mul_unsafe(
  y: U64 val)
: U64 val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [U64](builtin-U64) val

---

### div_unsafe



```pony
fun box div_unsafe(
  y: U64 val)
: U64 val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [U64](builtin-U64) val

---

### divmod_unsafe



```pony
fun box divmod_unsafe(
  y: U64 val)
: (U64 val , U64 val)
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* ([U64](builtin-U64) val , [U64](builtin-U64) val)

---

### mod_unsafe



```pony
fun box mod_unsafe(
  y: U64 val)
: U64 val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [U64](builtin-U64) val

---

### neg_unsafe



```pony
fun box neg_unsafe()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### op_and



```pony
fun box op_and(
  y: U64 val)
: U64 val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [U64](builtin-U64) val

---

### op_or



```pony
fun box op_or(
  y: U64 val)
: U64 val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [U64](builtin-U64) val

---

### op_xor



```pony
fun box op_xor(
  y: U64 val)
: U64 val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [U64](builtin-U64) val

---

### op_not



```pony
fun box op_not()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### add



```pony
fun box add(
  y: U64 val)
: U64 val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [U64](builtin-U64) val

---

### sub



```pony
fun box sub(
  y: U64 val)
: U64 val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [U64](builtin-U64) val

---

### mul



```pony
fun box mul(
  y: U64 val)
: U64 val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [U64](builtin-U64) val

---

### div



```pony
fun box div(
  y: U64 val)
: U64 val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [U64](builtin-U64) val

---

### divmod



```pony
fun box divmod(
  y: U64 val)
: (U64 val , U64 val)
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* ([U64](builtin-U64) val , [U64](builtin-U64) val)

---

### mod



```pony
fun box mod(
  y: U64 val)
: U64 val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [U64](builtin-U64) val

---

### neg



```pony
fun box neg()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### eq



```pony
fun box eq(
  y: U64 val)
: Bool val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [Bool](builtin-Bool) val

---

### ne



```pony
fun box ne(
  y: U64 val)
: Bool val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [Bool](builtin-Bool) val

---

### lt



```pony
fun box lt(
  y: U64 val)
: Bool val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [Bool](builtin-Bool) val

---

### le



```pony
fun box le(
  y: U64 val)
: Bool val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [Bool](builtin-Bool) val

---

### ge



```pony
fun box ge(
  y: U64 val)
: Bool val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [Bool](builtin-Bool) val

---

### gt



```pony
fun box gt(
  y: U64 val)
: Bool val
```
#### Parameters

*   y: [U64](builtin-U64) val

#### Returns

* [Bool](builtin-Bool) val

---

### hash64



```pony
fun box hash64()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### i8



```pony
fun box i8()
: I8 val
```

#### Returns

* [I8](builtin-I8) val

---

### i16



```pony
fun box i16()
: I16 val
```

#### Returns

* [I16](builtin-I16) val

---

### i32



```pony
fun box i32()
: I32 val
```

#### Returns

* [I32](builtin-I32) val

---

### i64



```pony
fun box i64()
: I64 val
```

#### Returns

* [I64](builtin-I64) val

---

### i128



```pony
fun box i128()
: I128 val
```

#### Returns

* [I128](builtin-I128) val

---

### ilong



```pony
fun box ilong()
: ILong val
```

#### Returns

* [ILong](builtin-ILong) val

---

### isize



```pony
fun box isize()
: ISize val
```

#### Returns

* [ISize](builtin-ISize) val

---

### u8



```pony
fun box u8()
: U8 val
```

#### Returns

* [U8](builtin-U8) val

---

### u16



```pony
fun box u16()
: U16 val
```

#### Returns

* [U16](builtin-U16) val

---

### u32



```pony
fun box u32()
: U32 val
```

#### Returns

* [U32](builtin-U32) val

---

### u64



```pony
fun box u64()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### u128



```pony
fun box u128()
: U128 val
```

#### Returns

* [U128](builtin-U128) val

---

### ulong



```pony
fun box ulong()
: ULong val
```

#### Returns

* [ULong](builtin-ULong) val

---

### usize



```pony
fun box usize()
: USize val
```

#### Returns

* [USize](builtin-USize) val

---

### f32



```pony
fun box f32()
: F32 val
```

#### Returns

* [F32](builtin-F32) val

---

### f64



```pony
fun box f64()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### i8_unsafe



```pony
fun box i8_unsafe()
: I8 val
```

#### Returns

* [I8](builtin-I8) val

---

### i16_unsafe



```pony
fun box i16_unsafe()
: I16 val
```

#### Returns

* [I16](builtin-I16) val

---

### i32_unsafe



```pony
fun box i32_unsafe()
: I32 val
```

#### Returns

* [I32](builtin-I32) val

---

### i64_unsafe



```pony
fun box i64_unsafe()
: I64 val
```

#### Returns

* [I64](builtin-I64) val

---

### i128_unsafe



```pony
fun box i128_unsafe()
: I128 val
```

#### Returns

* [I128](builtin-I128) val

---

### ilong_unsafe



```pony
fun box ilong_unsafe()
: ILong val
```

#### Returns

* [ILong](builtin-ILong) val

---

### isize_unsafe



```pony
fun box isize_unsafe()
: ISize val
```

#### Returns

* [ISize](builtin-ISize) val

---

### u8_unsafe



```pony
fun box u8_unsafe()
: U8 val
```

#### Returns

* [U8](builtin-U8) val

---

### u16_unsafe



```pony
fun box u16_unsafe()
: U16 val
```

#### Returns

* [U16](builtin-U16) val

---

### u32_unsafe



```pony
fun box u32_unsafe()
: U32 val
```

#### Returns

* [U32](builtin-U32) val

---

### u64_unsafe



```pony
fun box u64_unsafe()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

### u128_unsafe



```pony
fun box u128_unsafe()
: U128 val
```

#### Returns

* [U128](builtin-U128) val

---

### ulong_unsafe



```pony
fun box ulong_unsafe()
: ULong val
```

#### Returns

* [ULong](builtin-ULong) val

---

### usize_unsafe



```pony
fun box usize_unsafe()
: USize val
```

#### Returns

* [USize](builtin-USize) val

---

### f32_unsafe



```pony
fun box f32_unsafe()
: F32 val
```

#### Returns

* [F32](builtin-F32) val

---

### f64_unsafe



```pony
fun box f64_unsafe()
: F64 val
```

#### Returns

* [F64](builtin-F64) val

---

### compare



```pony
fun box compare(
  that: U64 val)
: (Less val | Equal val | Greater val)
```
#### Parameters

*   that: [U64](builtin-U64) val

#### Returns

* ([Less](builtin-Less) val | [Equal](builtin-Equal) val | [Greater](builtin-Greater) val)

---

## Private Functions

### _value



```pony
fun box _value()
: U64 val
```

#### Returns

* [U64](builtin-U64) val

---

