# SHA224
<span class="source-link">[[Source]](src/crypto/hash_fn.md#L65)</span>
```pony
primitive val SHA224 is
  HashFn ref
```

#### Implements

* [HashFn](crypto-HashFn) ref

---

## Constructors

### create
<span class="source-link">[[Source]](src/crypto/hash_fn.md#L65)</span>


```pony
new val create()
: SHA224 val^
```

#### Returns

* [SHA224](crypto-SHA224) val^

---

## Public Functions

### apply
<span class="source-link">[[Source]](src/crypto/hash_fn.md#L66)</span>


Compute the SHA224 message digest conforming to US Federal Information
Processing Standard FIPS PUB 180-4


```pony
fun tag apply(
  input: (String val | Array[U8 val] val))
: Array[U8 val] val
```
#### Parameters

*   input: ([String](builtin-String) val | [Array](builtin-Array)\[[U8](builtin-U8) val\] val)

#### Returns

* [Array](builtin-Array)\[[U8](builtin-U8) val\] val

---

### eq
<span class="source-link">[[Source]](src/crypto/hash_fn.md#L66)</span>


```pony
fun box eq(
  that: SHA224 val)
: Bool val
```
#### Parameters

*   that: [SHA224](crypto-SHA224) val

#### Returns

* [Bool](builtin-Bool) val

---

### ne
<span class="source-link">[[Source]](src/crypto/hash_fn.md#L66)</span>


```pony
fun box ne(
  that: SHA224 val)
: Bool val
```
#### Parameters

*   that: [SHA224](crypto-SHA224) val

#### Returns

* [Bool](builtin-Bool) val

---

