# Logger\[A: A\]
<span class="source-link">[[Source]](src/logger/logger.md#L110)</span>
```pony
class val Logger[A: A]
```

## Constructors

### create
<span class="source-link">[[Source]](src/logger/logger.md#L116)</span>


```pony
new val create(
  level: (Fine val | Info val | Warn val | 
    Error val),
  out: OutStream tag,
  f: {(A): String}[A] val,
  formatter: LogFormatter val = seq)
: Logger[A] val^
```
#### Parameters

*   level: ([Fine](logger-Fine) val | [Info](logger-Info) val | [Warn](logger-Warn) val | 
    [Error](logger-Error) val)
*   out: [OutStream](builtin-OutStream) tag
*   f: {(A): String}[A] val
*   formatter: [LogFormatter](logger-LogFormatter) val = seq

#### Returns

* [Logger](logger-Logger)\[A\] val^

---

## Public Functions

### apply
<span class="source-link">[[Source]](src/logger/logger.md#L127)</span>


```pony
fun box apply(
  level: (Fine val | Info val | Warn val | 
    Error val))
: Bool val
```
#### Parameters

*   level: ([Fine](logger-Fine) val | [Info](logger-Info) val | [Warn](logger-Warn) val | 
    [Error](logger-Error) val)

#### Returns

* [Bool](builtin-Bool) val

---

### log
<span class="source-link">[[Source]](src/logger/logger.md#L130)</span>


```pony
fun box log(
  value: A,
  loc: SourceLoc val = seq)
: Bool val
```
#### Parameters

*   value: A
*   loc: [SourceLoc](builtin-SourceLoc) val = seq

#### Returns

* [Bool](builtin-Bool) val

---

